.386
.model flat,stdcall
option casemap:none

include     \masm32\include\windows.inc

szCmp       PROTO :DWORD,:DWORD
GetProcAddr PROTO :DWORD,:DWORD

prC         TYPEDEF PROTO C :VARARG
LoadLibrary EQU <pr1 PTR LoadLib>
printf      EQU <prC PTR __printf>

.data

LLibrary        db "LoadLibraryA",0
FreeLibrary     db "FreeLibrary",0
ExitProcess     db "ExitProcess",0
_printf         db "printf",0
msvcrt          db "msvcrt.dll",0
msg             db 'Kernel address = %X',0

LoadLib         db 0FFh,025h	; define a jump entry
                dd pLoadLib


__printf        db 0FFh,025h
                dd pprintf


.data?

pLoadLib        dd ?
pprintf         dd ?
hLib            dd ?
hKernel32       dd ?

.code

start:

; The code to get the base of kernel32
; may not work on every version of Windows

    mov     ecx,[esp]

@@:

    xor     edx,edx
    dec     ecx
    mov     dx,[ecx+03ch]
    test    dx,0f800h
    jnz     @b
    cmp     ecx,[ecx+edx+34h]
    jnz     @b

    mov     hKernel32,ecx

    invoke  GetProcAddr,hKernel32,ADDR LLibrary
    mov     pLoadLib,eax

    invoke  LoadLibrary,ADDR msvcrt
    mov     hLib,eax

    invoke  GetProcAddr,eax,ADDR _printf
    mov     pprintf,eax
   
    invoke  printf,ADDR msg,hKernel32

    invoke  GetProcAddr,hKernel32,ADDR FreeLibrary
    push    hLib
    call    eax
    
    invoke  GetProcAddr,hKernel32,ADDR ExitProcess

    push    0
    call    eax

include     GetProcAddr.inc
include     szCmp.inc

END start

